<template>
  <div class="s">
    <v-sheet color class="text-h2 mx-3 px-4 pt-4 pb-3 v-sheet theme--light rounded-0" tile>
      <h2 class="text-h2 mb-1 text-left">我的项目</h2>
      <el-button class="mx-2 float-right" round type="primary" @click.stop="createProject = true">
        <!-- <v-icon dark>mdi-plus</v-icon> -->
        <i class="el-icon-plus">新建</i>
      </el-button>
      <el-dialog title="新建项目" :visible.sync="createProject" width="30%">
        <v-card-text>
          <v-text-field label="输入项目名" dense color="amber" v-model="newProjectName"></v-text-field>
          <v-text-field label="输入项目描述" dense color="orange" v-model="newProjectDesc" style="margin-top:20px"></v-text-field>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <el-button color="primary" plain @click="createProject = false">取消</el-button>
          <el-button type="primary" @click="createProject = false;create_project()">确认</el-button>
        </v-card-actions>
      </el-dialog>
    </v-sheet>

    <v-container>
      <v-row dense>
        <v-col v-for="project in projects" :key="project.projectName" :cols="6">
          <v-card class="mx-auto mr-2 mb-3 ml-3" elevation="3">
            <v-card-text>
              <div>项目名称</div>
              <p class="display-1 text--primary">{{ project.projectName }}</p>
              <p class="context">
                创建时间：{{ project.createTime.substring(0,project.createTime.lastIndexOf('.')).replace("T"," ") }}
                <span
                  class="little-divider"
                ></span>
                所有者：{{ project.owner }}
                <br />项目成员
                <v-avatar size="20" class="white--text" color="green">{{project.member.length}}</v-avatar>：
                <v-chip
                  v-for="userr in project.users"
                  :key="userr.userName"
                  :color="userr.color"
                  class="white--text mx-1"
                >
                  <v-avatar left>
                    <v-icon>{{userr.avatar}}</v-icon>
                  </v-avatar>
                  {{userr.nickName}}
                  <v-icon
                    right
                    small
                    @click="del_member(project.projectName, userr.userName)"
                    v-if="project.owner===user"
                  >mdi-close</v-icon>
                </v-chip>
              </p>
              <v-divider class="mx-4"></v-divider>
              <div class="text--primary" style="min-height: 200px">
                项目简介：{{ project.projectDesc }}
                <v-btn icon @click="$set(project,'showEdit', true)" v-if="project.owner===user">
                  <v-icon>mdi-file-edit-outline</v-icon>
                </v-btn>
                <v-textarea
                  v-if="project.showEdit"
                  outlined
                  v-model.trim="description"
                  color="teal"
                ></v-textarea>
                <v-btn v-if="project.showEdit" @click="newDesc(project)">确定</v-btn>
              </div>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>

              <v-btn
                title="添加成员"
                icon
                @click.stop="addMember = true;selProjectName=project.projectName"
                v-if="project.owner===user"
              >
                <v-icon>mdi-account-plus</v-icon>
              </v-btn>
              <v-dialog v-model="addMember" width="500">
                <v-card>
                  <v-card-title class="headline">添加成员</v-card-title>
                  <v-card-text>
                    <v-text-field label="输入成员名" dense color="primary" v-model.trim="newMemberName"></v-text-field>
                  </v-card-text>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="addMember = false">取消</v-btn>
                    <v-btn
                      color="primary"
                      text
                      @click="addMember = false;add_member(selProjectName)"
                    >确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-btn
                title="移交所有权"
                icon
                @click.stop="replaceOwner = true;selProjectName=project.projectName"
                v-if="project.owner===user"
              >
                <v-icon>mdi-account-convert</v-icon>
              </v-btn>
              <v-dialog v-model="replaceOwner" width="500">
                <v-card>
                  <v-card-title class="headline">移交所有权</v-card-title>
                  <v-card-text>
                    <v-text-field label="输入成员名" dense color="primary" v-model.trim="newMemberName"></v-text-field>
                  </v-card-text>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="replaceOwner = false">取消</v-btn>
                    <v-btn
                      color="primary"
                      text
                      @click="replaceOwner = false;replace_owner(selProjectName)"
                    >确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>

              <v-btn
                title="删除项目"
                icon
                @click="delete_project(project.projectName)"
                v-if="project.owner===user"
              >
                <v-icon>mdi-delete</v-icon>
              </v-btn>

              <v-btn title="离开项目" icon @click="leave_project(project.projectName)" class="ml-0">
                <v-icon>mdi-export</v-icon>
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
export default {
  name: "manageProject",
  data: () => ({
    falsee: false,
    errorMessage: "",
    successMessage: "",
    user: "",
    projects: [],

    newMemberName: "",
    selProjectName: "",
    newProjectName: "",
    newProjectDesc: "",
    description: "",

    addMember: false,
    delMember: false,
    leaveProject: false,
    delProject: false,
    createProject: false,
    showEdit: false,
    replaceOwner: false
  }),
  components: {},
  methods: {
    login_alert(message) {
      this.errorMessage = "" + message;
    },
    messagee(message) {
      this.successMessage = "" + message;
    },
    add_member(ProjectName) {
      if (!ProjectName.length) {
        return;
      }

      if (!this.newMemberName.length) {
        return;
      }

      if (this.newMemberName.length > 10) {
        return;
      }

      const self = this;
      this.$axios({
        method: "post",
        url: `/addmember`,
        data: {
          projectName: ProjectName,
          userName: self.newMemberName
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "ADDMEMBER_SUCCESS") {
            self.messagee("添加成功！");
            window.location.reload();
          } else if (data.status === "ADDMEMBER_FAILURE") {
            alert(data.message);
          } else {
            alert("出错了！");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    replace_owner(ProjectName) {
      if (!ProjectName.length) {
        return;
      }

      if (!this.newMemberName.length) {
        return;
      }

      if (this.newMemberName.length > 10) {
        return;
      }

      const self = this;
      this.$axios({
        method: "post",
        url: `/replaceowner`,
        data: {
          projectName: ProjectName,
          newOwner: self.newMemberName
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "success") {
            self.messagee("添加成功！");
            window.location.reload();
          } else {
            alert(data.message);
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    del_member(ProjectName, UserName) {
      if (!ProjectName.length) {
        return;
      }

      if (ProjectName.length > 20) {
        return;
      }

      if (!UserName.length) {
        return;
      }

      if (UserName.length > 10) {
        return;
      }

      const self = this;
      this.$axios({
        method: "post",
        url: `/delmember`,
        data: {
          projectName: ProjectName,
          userName: UserName
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "DELMEMBER_SUCCESS") {
            // 向后端发起申请，删除room里的user
            self.$axios({
              method: "post",
              url: `/codeEdit`,
              data: {
                operation: "DeleteRoomUser",
                projectName: ProjectName,
                userName: UserName
              }
            });

            self.messagee("删除成功！");
            window.location.reload();
          } else if (data.status === "DELMEMBER_FAILURE") {
            alert(data.message);
          } else {
            alert("出错了！");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    delete_project(ProjectName) {
      if (!ProjectName.length) {
        return;
      }

      if (ProjectName.length > 20) {
        return;
      }

      if (!this.user.length) {
        return;
      }

      if (this.user.length > 10) {
        return;
      }
      const self = this;
      this.$axios({
        method: "post",
        url: `/delproject`,
        data: {
          projectName: ProjectName,
          userName: this.user
        }
      }).then(res => {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "DELETE_SUCCESS") {
            // 向后端发起申请，删除room里的user
            self.$axios({
              method: "post",
              url: `/codeEdit`,
              data: {
                operation: "DeleteRooms",
                projectName: ProjectName,
                userName: self.user
              }
            });
            self.messagee("删除成功！");
            window.location.reload();
          } else if (data.status === "DELETE_FAILURE") {
            alert(data.message);
          } else {
            alert("出错了！");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    create_project() {
      if (!this.newProjectName.length) {
        alert("项目名称不得为空！");
        return;
      }

      if (this.newProjectName.length > 20) {
        alert("项目名称不得超过20个字符！");
        return;
      }
      const self = this;
      this.$axios({
        method: "post",
        url: `/creatproject`,
        data: {
          projectName: this.newProjectName,
          projectDesc: this.newProjectDesc,
          owner: self.user
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "Creat_SUCCESS") {
            self.messagee("创建成功！");
            window.location.reload();
          } else if (data.status === "PROJECTNAME_DUPLICATE") {
            alert(data.message);
          } else {
            alert("出错了！");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    leave_project(ProjectName) {
      const self = this;
      this.$axios({
        method: "post",
        url: `/delmember`,
        data: {
          projectName: ProjectName,
          userName: this.user
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "DELMEMBER_SUCCESS") {
            // 向后端发起申请，删除room里的user
            self.$axios({
              method: "post",
              url: `/codeEdit`,
              data: {
                operation: "DeleteRoomUser",
                projectName: ProjectName,
                userName: self.user
              }
            });
            window.location.reload();
          } else if (data.status === "DELMEMBER_FAILURE") {
            alert(data.message);
          } else {
            alert("出错了！");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    get_project_members(Project) {
      let self = this;
      this.$axios({
        method: "post",
        url: `/project`,
        data: {
          operation: "ProjectUsers",
          projectName: Project.projectName,
          userName: self.userName
        }
      }).then(function(res) {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            self.$set(
              self.projects[self.projects.indexOf(Project)],
              "users",
              data.data
            );
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    newDesc(Project) {
      const self = this;
      Project.showEdit = false;
      console.log(this.user);
      console.log(this.description);
      this.$axios({
        method: "post",
        url: `/changedesc`,
        data: {
          projectName: Project.projectName,
          userName: this.user,
          newDesc: this.description
        }
      }).then(function(res) {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "success") {
            self.$set(Project, "projectDesc", self.description);
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    }
  },
  mounted() {
    let self = this;
    this.user = this.$store.getters.userName;
    this.$axios({
      method: "post",
      url: `/showprojects`,
      data: {
        userName: this.user
      }
    }).then(res => {
      if (res.status === 200) {
        const data = res.data;
        if (data.status === "SUCCESS") {
          this.projects = data.projects;
          for (let project of self.projects) {
            self.get_project_members(project);
          }
        } else {
          alert("出错了！");
        }
      } else {
        alert("连接失败。\n请检查您的网络状态。");
      }
    });
  },
  computed: {}
};
</script>

<style scoped>
.s {
  margin-left: calc(60px + 10%);
  width: calc(80% - 60px);
}
.rightwrap {
  display: flex;
  justify-content: flex-end;
}
.little-divider {
  width: 1.5em;
  display: inline-block;
}
</style>
